__author__ = "mfreer"
__date__ = "$Date:: 2011-09-09 17:37#$"
__version__ = "$Revision:: 80        $"
__all__ = ["Unit", "BaseUnit"]

COMMENT_CHAR = '#'

from egads.core.units.registry import unit_registry

#basic_units = []
#
#derived_units = []
#
#f = open('egads/core/udunits.dat', 'r')
#
#for line in f:
#    if not line.startswith(COMMENT_CHAR) and len(line) > 2:
#        print line
#        print len(line)
#
#        if '#' in line:
#            line = line[:line.find(COMMENT_CHAR)]
#
#        read_unit = line[:24].strip()
#        read_plural = line[25]
#        read_value = line[26:].strip()
#
#
#        if read_value == '':
#            basic_units.append([read_unit, read_plural])
#        else:
#            derived_units.append([read_unit, read_plural, read_value])
#
#f.close()
#
#print basic_units
#print derived_units
#

class Unit(object):
    """This is the basic unit class from which all units are derived. """

    def __init__(self, name, symbol=None, formula=None, aliases=[], dimensionality={}):

        self.name = name
        self.symbol = symbol
        self.formula = formula
        self.aliases = aliases
        self.dimensionality = dimensionality

        unit_registry[name] = self
        if symbol:
            unit_registry[symbol] = self
        for alias in aliases:
            unit_registry[alias] = self

    def __mul__(self, other):
        assert isinstance(other, Unit)



class BaseUnit(Unit):

    _default_unit = None

    def __init__(self, name, symbol=None, formula=None, aliases=[]):
        super(BaseUnit, self).__init__(name, symbol, formula, aliases,
                                       dimensionality={self:1})

        cls = type(self)
        if cls._default_unit is None:
            cls._default_unit = self

    @classmethod
    def get_default_unit(cls):
        return cls._default_unit
    @classmethod
    def set_default_unit(cls, unit):
        if unit is None:
            return
        if isinstance(unit, str):
            unit = unit_registry[unit]
        cls._default_unit = unit

class MassUnit(BaseUnit):
    pass

class LengthUnit(BaseUnit):
    pass

class TimeUnit(BaseUnit):
    pass

